<script setup lang="ts">
import { inject, ref, watchPostEffect, isProxy, toRaw } from "vue";
import { useThrottleFn } from "@vueuse/core";

import injectionSymbols from "./injectionSymbols";

import getAlgoWorker from "@/lib/get-worker.js";
import { meshDescriptorList } from "@/data/meshDescriptorsFlat";
import translations from "../../language/translations.json";

import type { MeSHDescriptor } from "@/types/mesh";

export interface Props {
  descriptors?: MeSHDescriptor[];
}

const props = withDefaults(defineProps<Props>(), {
  descriptors: () => meshDescriptorList,
});

const meshDescriptorsSelectedDirectly = inject(
  injectionSymbols.meshDescriptorsSelectedDirectly,
)!;

const searchTerm = ref("");
const infiniteScrollCounter = ref(0);

const lang = inject(injectionSymbols.language)!;

const meshDescriptorsFiltered = ref<MeSHDescriptor[]>();
watchPostEffect((onCleanup) => {
  const { worker, wrapped } = getAlgoWorker();

  // Proxy objects can't be passed to workers
  const descriptors = isProxy(props.descriptors)
    ? toRaw(props.descriptors)
    : props.descriptors;

  wrapped
    .autocomplete(
      descriptors,
      searchTerm.value,
      lang.value,
      meshDescriptorsSelectedDirectly.value.map((i) => i.ui),
      infiniteScrollCounter.value,
    )
    .then((data) => {
      meshDescriptorsFiltered.value = data;
    })
    .finally(() => {
      worker.terminate();
    });
  onCleanup(() => {
    worker.terminate();
  });
});

function onSearchFieldType(text: string) {
  searchTerm.value = text;
  infiniteScrollCounter.value = 0;
}

const onInfiniteScroll = useThrottleFn(async () => {
  infiniteScrollCounter.value++;
}, 1000);
</script>

<template>
  <div class="mesh-autocomplete">
    <o-taginput
      v-model="meshDescriptorsSelectedDirectly"
      :data="meshDescriptorsFiltered"
      allowAutocomplete
      checkScroll
      :field="`name_${lang}`"
      :placeholder="translations[lang].searchMeshDescriptor"
      icon="search"
      @input="onSearchFieldType"
      @scroll-end="onInfiniteScroll"
    />
  </div>
</template>

<style scoped>
.mesh-autocomplete {
  text-align: left;
}
</style>

<style>
.mesh-autocomplete .tag {
  height: unset !important;
  min-height: calc(2em - 1px);
  white-space: normal;
}
</style>
